%!TEX root=../../thesis.tex
%!TEX file=content/appendix/root-finding.tex

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\chapter{Root-Finding Problem}\label{app:chap:root-finding}

Root-finding is the problem of finding the real or complex valued number~$x$ of a continuous function~$f \colon \mathds{R} \to \mathds{R}$,~$x \mapsto f \of{x}$, for which holds~$f \of{x} \equiv 0$.
While sometimes roots can be expressed in closed form, in the most general case it is not possible to compute exactly the root of a function\textemdash let alone due to numerical rounding precision.
One can also apply the root-finding problem to cases, where one wants to find equality of two functions\textemdash usually functions nIinear in one or more variables\textemdash for number~$x$.
That is, we can rewrite~$f \of{x} = g \of{x}$ to read~$h \of{x} = f \of{x} - g \of{x}$, for which we can now apply the root-finding problem to~$h \of{x}$ \textWrt~$x$.
It must be noted that there may be cases where root-finding algorithms do not find a root which, however, does not state there exist no root.
    
In most cases, root-finding algorithms are iterative procedures, using a start point or initial guess to provide a sequence of numbers that converge toward the root.
During each iteration, the algorithm ideally proceeds closer and closer to the root and provides increasingly more accurate approximations of the root.
Eventually, the iteration has to be stopped due to rounding precision, perfect equality of~$f \of{x} \equiv 0$ can never be achieved.
Therefore, every root-finding algorithm provides only an approximation, not the exact root solution.




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\input{content/appendix/root-finding/bracketing}




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\input{content/appendix/root-finding/iterative}
